unit udmdOrder;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, ulibTrDBTables;

type
  TdmdOrder = class(TDataModule)
    qryrOrder: TrQuery;
    sqryrOrder: TDataSource;
    updOrder: TUpdateSQL;
    tblNextOder: TTable;
    qryrOrderOrderNo: TFloatField;
    qryrOrderCustNo: TFloatField;
    qryrOrderSaleDate: TDateTimeField;
    qryrOrderShipDate: TDateTimeField;
    qryrOrderEmpNo: TIntegerField;
    qryrOrderShipToContact: TStringField;
    qryrOrderShipToAddr1: TStringField;
    qryrOrderShipToAddr2: TStringField;
    qryrOrderShipToCity: TStringField;
    qryrOrderShipToState: TStringField;
    qryrOrderShipToZip: TStringField;
    qryrOrderShipToCountry: TStringField;
    qryrOrderShipToPhone: TStringField;
    qryrOrderShipVIA: TStringField;
    qryrOrderPO: TStringField;
    qryrOrderTerms: TStringField;
    qryrOrderPaymentMethod: TStringField;
    qryrOrderItemsTotal: TCurrencyField;
    qryrOrderTaxRate: TFloatField;
    qryrOrderFreight: TCurrencyField;
    qryrOrderAmountPaid: TCurrencyField;
    tblNextOderNewKey: TFloatField;
    tblNextOderItem: TTable;
    tblNextOderItemNewKey: TFloatField;
    sqryrOrderItems: TDataSource;
    qryrOrderFingerPrint: TStringField;
    updOrderItems: TUpdateSQL;
    qryrOrderItems: TrQuery;
    qryrOrderItemsOrderNo: TFloatField;
    qryrOrderItemsItemNo: TFloatField;
    qryrOrderItemsPartNo: TFloatField;
    qryrOrderItemsQty: TIntegerField;
    qryrOrderItemsDiscount: TFloatField;
    qryrOrderItemsCost: TCurrencyField;
    qryrOrderItemsListPrice: TCurrencyField;
    qryrOrderItemsItemPrice: TCurrencyField;
    qryOrderItemsDelete: TQuery;
    procedure qryrOrderNewRecord(DataSet: TDataSet);
    procedure qryOrderItemsNewRecord(DataSet: TDataSet);
    procedure qryrOrderCalcFields(DataSet: TDataSet);
    procedure qryrOrderAfterOpen(DataSet: TDataSet);
    procedure qryOrderItemsCalcFields(DataSet: TDataSet);
    procedure qryrOrderBeforeDelete(DataSet: TDataSet);
    procedure qryrOrderAfterDelete(DataSet: TDataSet);
    procedure qryrOrderDeleteError(DataSet: TDataSet; E: EDatabaseError; var Action: TDataAction);
    procedure qryrOrderItemsAfterInsert(DataSet: TDataSet);
    procedure qryrOrderItemsAfterDelete(DataSet: TDataSet);
    procedure qryrOrderItemsAfterPost(DataSet: TDataSet);
    procedure qryrOrderItemsAfterOpen(DataSet: TDataSet);
  private
    { Private-Deklarationen }
    procedure CalcItemTotal;
  public
    { Public-Deklarationen }
  end;

var
  dmdOrder: TdmdOrder;

implementation

uses udmdMain;

{$R *.DFM}

procedure TdmdOrder.CalcItemTotal;
var
  TempTotal: Extended;
  PrevRecord: TBookmark;
  fPostIt: Boolean;
begin

//  if DeletingItems then Exit;		{ don't calculate if deleting all items }
  PrevRecord := qryrOrderItems.GetBookmark;	{ returns nil if table is empty }
  try
    qryrOrderItems.DisableControls;
    qryrOrderItems.First;
    TempTotal := 0;			{ use temp for efficiency }
    while not qryrOrderItems.EOF do begin
      TempTotal := TempTotal + qryrOrderItemsItemPrice.Value;
      qryrOrderItems.Next;
    end;
  finally
     qryrOrderItems.EnableControls;
     if PrevRecord <> nil then begin
       qryrOrderItems.GoToBookmark(PrevRecord);
       qryrOrderItems.FreeBookmark(PrevRecord);
     end;
  end;

  qryrOrder.DisableControls;
  try
    fPostIt := qryrOrder.State = dsBrowse;
    if qryrOrder.State = dsBrowse Then
      qryrOrder.Edit;
    qryrOrderItemsTotal.Value := TempTotal;
    if fPostIt Then
      qryrOrder.Post;
  finally
    qryrOrder.EnableControls;
  end;

end;

procedure TdmdOrder.qryrOrderNewRecord(DataSet: TDataSet);
Var retries: Integer;
    Index: Double;
begin
  retries := 0;
  While True do try
    tblNextOder.Close;
    tblNextOder.Exclusive := True;
    tblNextOder.Open;
    try
      tblNextOder.Edit;
      try
        Index := tblNextOderNewKey.AsFloat + 1;
        tblNextOderNewKey.AsFloat := Index;
        tblNextOder.Post;
        qryrOrderOrderNo.AsFloat := Index;
      except
        tblNextOder.Cancel;
        raise;
      end;
    finally
      tblNextOder.Close;
    end;
    break;
  except
    if retries > 5 then raise;
    Inc(retries);
    Sleep(100);
  end;
end;

procedure TdmdOrder.qryOrderItemsNewRecord(DataSet: TDataSet);
Var retries: Integer;
    Index: Double;
begin
//  qryrOrder.CheckBrowseMode;
  if qryrOrder.State in dsEditModes Then
    qryrOrder.Post;
  retries := 0;
  While True do try
    tblNextOderItem.Close;
    tblNextOderItem.Exclusive := True;
    tblNextOderItem.Open;
    try
      tblNextOderItem.Edit;
      try
        Index := tblNextOderItemNewKey.AsFloat + 1;
        tblNextOderItemNewKey.AsFloat := Index;
        tblNextOderItem.Post;
        qryrOrderItemsItemNo.AsFloat := Index;
      except
        tblNextOderItem.Cancel;
        raise;
      end;
    finally
      tblNextOderItem.Close;
    end;
    break;
  except
    if retries > 5 then raise;
    Inc(retries);
    Sleep(100);
  end;
  qryrOrderItemsOrderNo.AsFloat := qryrOrderOrderNo.AsFloat;
end;

procedure TdmdOrder.qryrOrderCalcFields(DataSet: TDataSet);
begin
  qryrOrderFingerPrint.Text := '(null)';
end;

procedure TdmdOrder.qryrOrderAfterOpen(DataSet: TDataSet);
begin
  qryrOrderItems.Open;
end;

procedure TdmdOrder.qryOrderItemsCalcFields(DataSet: TDataSet);
begin
  qryrOrderItemsItemPrice.AsCurrency :=
    qryrOrderItemsQty.AsFloat *
    qryrOrderItemsListPrice.AsCurrency *
    ((100 - qryrOrderItemsDiscount.AsFloat) / 100.0);
end;

procedure TdmdOrder.qryrOrderBeforeDelete(DataSet: TDataSet);
begin
  dmdMain.dbDemo.StartTransaction;
  with qryOrderItemsDelete do Begin
    ParamByName('OrderNo').AsFloat := qryrOrderOrderNo.AsFloat;
    ExecSQL;
  End;
end;

procedure TdmdOrder.qryrOrderAfterDelete(DataSet: TDataSet);
begin
  dmdMain.dbDemo.Commit;
end;

procedure TdmdOrder.qryrOrderDeleteError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
begin
  dmdMain.dbDemo.Rollback;
  Action := daFail;
end;

procedure TdmdOrder.qryrOrderItemsAfterInsert(DataSet: TDataSet);
begin
  CalcItemTotal;
end;

procedure TdmdOrder.qryrOrderItemsAfterDelete(DataSet: TDataSet);
begin
  CalcItemTotal;
end;

procedure TdmdOrder.qryrOrderItemsAfterPost(DataSet: TDataSet);
begin
  CalcItemTotal;
end;

procedure TdmdOrder.qryrOrderItemsAfterOpen(DataSet: TDataSet);
begin
  DataSet := nil;
end;

end.
